﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.Web.UI.WebControls.Client.Olap;
using Syncfusion.Olap.DataProvider;
using Syncfusion.Olap.Reports;
using Syncfusion.Olap.Manager;
using Syncfusion.Olap.Data;

namespace Olapclient_snapdate
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                string connectionString = "Data Source=http://bi.syncfusion.com/olap/msmdpump.dll; Initial Catalog=Adventure Works DW 2008 SE;";
                OlapDataManager DataManager = new OlapDataManager(connectionString);
                this.OlapClient1.OlapDataManager = DataManager;
                this.OlapClient1.DataBind();
            }
            this.OlapClient1.TreeNodeDropped += OlapClient1_TreeNodeDropped;
        }

        void OlapClient1_TreeNodeDropped(object sender, TreeNodeDroppedEventArgs e)
        {
            DimensionElement excludedRowElement = new DimensionElement();

            if ((e.MetaTreeNode.Name == "Customer" && (e.MetaTreeNode.Properties[2].Value as Hierarchy).Name == "Customer Geography"))
            {
                //Excluding members other than "Australia" and "Canada" from the dropped dimension "Customer"
                foreach (MetaTreeNode child in e.MetaTreeNode.ChildNodes)
                {
                    if (child.Name != "Australia" && child.Name != "Canada")
                    {
                        string memberName = child.Name;
                        string hierarchyName = (child.Properties[0].Value as Member).ParentHierarchy.ToString();
                        string levelName = (child.Properties[0].Value as Member).ParentLevel.Name;
                        string memberUniqueName = (child.Properties[0].Value as Member).UniqueName;

                        excludedRowElement.Name = e.MetaTreeNode.Name;
                        excludedRowElement.AddLevel(hierarchyName, levelName);
                        excludedRowElement.Hierarchy.LevelElements[levelName].Add(new MemberElement() { Name = memberName, UniqueName = memberUniqueName });
                    }
                }
                e.ExcludedDimensionElement = excludedRowElement;
            }
        }
    }
}